=== RNN/rnn_compiler/requirements.txt ===
numpy==1.17.2
tqdm
networkx
