=== RNN/rnn_quantizer/requirements.txt ===
torch >= 1.1.0
torchvision >=0.3.0
sklearn
scipy==1.3.1
numpy==1.17.2
tqdm
ninja
