=== debian/changelog ===
vitis-ai (1.3.2-0ubuntu7) impish; urgency=medium

  * Build with -Wno-error=range-loop-construct and -D_GLIBCXX_USE_NANOSLEEP
    to fix build failure with gcc-11.
  * debian/patches/gcc-11-sleep_for.patch: #include <thread>.
  * debian/patches/nonnull.patch: fix dereferences of null pointers.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 26 Aug 2021 13:59:44 -0700

vitis-ai (1.3.2-0ubuntu6) impish; urgency=medium

  * Build-depend on libboost-filesystem-dev instead of using a versioned
    dependency.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 26 Aug 2021 15:39:36 +0000

vitis-ai (1.3.2-0ubuntu5) hirsute; urgency=medium

  * debian/vitis-ai-runtime.links, debian/vitis-ai-runtime.install: Do not
    install any subdirectories into /usr/bin and use /usr/lib instead, with
    the vaitrace symlink modified.
  * Cleanup patches and copyright.

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@ubuntu.com>  Wed, 14 Apr 2021 15:00:34 +0200

vitis-ai (1.3.2-0ubuntu4) hirsute; urgency=medium

  * Workaround duplicate definition of SSDOutputInfo

 -- Alfonso Sanchez-Beato (email Canonical) <alfonso.sanchez-beato@canonical.com>  Tue, 13 Apr 2021 17:55:06 +0200

vitis-ai (1.3.2-0ubuntu3) hirsute; urgency=medium

  * Add watch file and fix lintian warnings

 -- Alfonso Sanchez-Beato (email Canonical) <alfonso.sanchez-beato@canonical.com>  Mon, 12 Apr 2021 14:42:07 +0200

vitis-ai (1.3.2-0ubuntu2) hirsute; urgency=medium

  * Rebuild for hirsute

 -- Alfonso Sanchez-Beato (email Canonical) <alfonso.sanchez-beato@canonical.com>  Thu, 25 Mar 2021 11:48:21 +0100

vitis-ai (1.3.2-0ubuntu1) focal; urgency=medium

  * Update to 1.3.2

 -- Alfonso Sanchez-Beato (email Canonical) <alfonso.sanchez-beato@canonical.com>  Wed, 24 Mar 2021 17:54:55 +0100

vitis-ai (1.3-1ubuntu2) focal; urgency=medium

  * Change cross-compile option to is_edge.
    Vitis AI thinks that edge <-> cross compile. Fix it to allow local
    builds, by using a new cmake variable called IS_EDGE to determine
    whether this is an edge platform or not, instead of the cmake internal
    variable CMAKE_CROSSCOMPILING.

 -- Alfonso Sanchez-Beato (email Canonical) <alfonso.sanchez-beato@canonical.com>  Mon, 18 Jan 2021 15:13:06 +0100

vitis-ai (1.3-1ubuntu1) focal; urgency=medium

  * Build from v1.3 tag from https://github.com/Xilinx/Vitis-AI

 -- Alfonso Sanchez-Beato (email Canonical) <alfonso.sanchez-beato@canonical.com>  Thu, 07 Jan 2021 15:48:45 +0100
